Redmine - Defect #31831

Back url parse in validation
2019-07-31 12:04 - Tibinko H

Status: Closed Start date:

Priority: Normal Due date:

Assignee: Marius BALTEANU % Done: 0%
Category: Code cleanup/refactoring Estimated time: 0.00 hour
Target version: 6.0.0

Resolution: Fixed Affected version: 4.04
Description

Hello,

for example on issues screen, when you apply filters, it generates an url containing:

ut£8=[

Because of this bulk_edit (for instance) is unable to redirect back to this url.
The reason is a function in application_controller.rb - validate_back_url

URI.parse (back_url) is unable to parse the special character mentioned above.

The quicke workaround would be

URI.parse (URI.encode (back_url))

but i am not sure that is sufficient.

Related issues:

Related to Redmine - Defect #31552: View switches from gantt to list after ed... Closed
Related to Redmine - Feature #40190: Stop appending the utf8 checkmark parame... Closed
Related to Redmine - Defect #41930: Redirection after signing in fails when t... Closed

Associated revisions

Revision 22710 - 2024-02-14 00:17 - Marius BALTEANU

Replaces URl.parse with Addressable::URIl.parse(url) to enhance robustness of validate_back_url (#31831).

Patch by Go MAEDA (@maeda).

History

#1 - 2019-08-01 08:09 - Mizuki ISHIKAWA

It looks good.
| have also suggested the same fix (#31552#note-2).

#2 - 2019-08-01 10:20 - Tibinko H

Oh, ok. Did not see that, | am going to put this isssue to resolved then.

#3 - 2019-08-01 10:20 - Tibinko H

- Status changed from New to Resolved

#4 - 2019-08-01 10:33 - Marius BALTEANU

- Status changed from Resolved to New

Tibinko H wrote:

Oh, ok. Did not see that, | am going to put this isssue to resolved then.
https://www.redmine.org/issues/31552#note-2

It was committed another solution in that ticket.
#5 - 2019-08-01 10:40 - Tibinko H
Marius BALTEANU wrote:

Tibinko H wrote:

Oh, ok. Did not see that, | am going to put this isssue to resolved then.

It was committed another solution in that ticket.

Is it not exactly the same as | wrote above?
#6 - 2019-08-01 10:41 - Mizuki ISHIKAWA
Tibinko H wrote:

Oh, ok. Did not see that, | am going to put this isssue to resolved then.

| think this problem has not been solved yet.

Sorry, my comment(#31831#note-1) may have misled you.
In #31552 issue, #31552#note-3 changes were finally committed, not #31552#note-2 changes.
#31552#note-3 changes were a partial fix and does not solve the bulk_edit probrem.

URl.parse(URI.encode(back_url))

I thought that your suggestion for solving the problem that occurs with bulk_edit is good.

#7 - 2019-08-01 10:49 - Go MAEDA

- Target version set to Candidate for next minor release

Tibinko H, thank you for reporting this issue.
Here is a diff of your workaround.

diff --git a/app/controllers/application_controller.rb b/app/controllers/application_controller.rb
index 06e2d702c..afbb30f3e 100644

-—— a/app/controllers/application_controller.rb

+++ b/app/controllers/application_controller.rb

@@ -440,7 +440,7 Q@ class ApplicationController < ActionController::Base

end
begin
= uri = URI.parse (back_url)
+ uri = URI.parse (URI.encode (back_url))

rescue URI::InvalidURIError
return false
end

#8 - 2019-08-01 10:51 - Go MAEDA

- Related to Defect #31552: View switches from gantt to list after editing an issue added

#9 - 2024-02-04 05:47 - Go MAEDA

You can fix this problem by preventing Rails from appending a "utf8" parameter to form URLs. This can be achieved by setting
config.action_view.default_enforce_utf8 to false.
https://guides.rubyonrails.org/v7.1/configuring.html#config-action-view-default-enforce-utf8

We can safely remove the "utf8=[". This is because this is a workaround for Internet Explorer <=8 and Microsoft and Redmine no longer support the
browser.

diff --git a/app/controllers/application_controller.rb b/app/controllers/application_controller.rb
index 9bdéb83la..adl6b0e77 100644

-—- a/app/controllers/application_controller.rb

+++ b/app/controllers/application_controller.rb

@@ -475,11 +475,6 Q@ class ApplicationController < ActionController::Base
url = params|[:back_url]
if url.nil? && referer = request.env['HTTP_REFERER']
url = CGI.unescape (referer.to_s)

= # URLs that contains the utf8=[checkmark] parameter added by Rails are
= # parsed as invalid by URI.parse so the redirect to the back URL would
N # not be accepted (ApplicationController#validate_back_url would return
f # false)
f url.gsub! (/ (\?|&)utf8=\u2713&?/, '\1'")

end

url

end

diff --git a/config/application.rb b/config/application.rb
index 069796185..1lbeeb2db2 100644
-—— a/config/application.rb
+++ b/config/application.rb
@@ -45,6 +45,9 @@ module RedmineApp

config.action_mailer.delivery_job = "ActionMailer::MailDeliveryJob"
+ # Stop appending "utf8=0" to form URLs
+ config.action_view.default_enforce_utf8 = false

# Set Time.zone default to the specified zone and make Active Record auto-convert to this zone.
# Run "rake -D time" for a list of tasks for finding time zone names. Default is UTC.
# config.time_zone = 'Central Time (US & Canada)'

#10 - 2024-02-05 03:09 - Go MAEDA
- Related to Feature #40190: Stop appending the utf8 checkmark parameter to form URLs added

#11 - 2024-02-13 10:16 - Go MAEDA
- File 31831.patch added

| have opened #40190 and posted the patch pasted in #note-9.

Apart from that patch, | suggest replacing URI.parse with Addressable::URI.parse(url) to address the reported issue. This change is useful for
handling URLs containing non-ASCII characters, as demonstrated below.

irb(main) : 001> url = 'http://www.example.com/?utf8=0"

=> "http://www.example.com/?utf8=0"

irb(main) :002> URI.parse (url)

/Users/maeda/.rbenv/versions/3.1.4/1ib/ruby/3.1.0/uri/rfc3986_parser.rb:20:in “split': URI must be ascii only
"http://www.example.com/?utf£8=\u2713" (URI::InvalidURIError)

irb (main) : 003> Addressable::URI.parse (url)

=> #<Addressable::URI:0x9b14 URI:http://www.example.com/?utf8=[0>

The replacement not only fixes the immediate issue but also enhances the robustness of validate_back_url. It remains beneficial even after the patch
in #40190 is merged.

#12 - 2024-02-13 11:42 - Marius BALTEANU
- Assignee set to Marius BALTEANU

#13 - 2024-02-14 00:18 - Marius BALTEANU
- Category set to Code cleanup/refactoring
- Status changed from New to Resolved

- Resolution set to Fixed

Committed the patch after I've committed the one from #40190. Go MAEDA, are you thinking to merge this to stable branches without the changes
from #401907?

#14 - 2024-02-14 02:23 - Go MAEDA

- Target version changed from Candidate for next minor release to 6.0.0

Marius BALTEANU wrote in #note-13:

Go MAEDA, are you thinking to merge this to stable branches without the changes from #401907?
| think we don't need to merge this change to stable branches because the issue is very minor.

#15 - 2024-02-14 08:59 - Marius BALTEANU

- Status changed from Resolved to Closed

#16 - 2025-01-27 03:39 - Go MAEDA

- Related to Defect #41930: Redirection after signing in fails when the back_url includes a port number added

Files
31831.patch 1.2 KB 2024-02-13 Go MAEDA
